std::unordered_multiset< _Value, _Hash, _Pred, _Alloc > Class Template Reference
Unordered Associative

Inherits std::__allow_copy_cons< bool >.

## Public Types

typedef _Hashtable::key_type | key_type
typedef _Hashtable::value_type | value_type
typedef _Hashtable::hasher | hasher
typedef _Hashtable::key_equal | key_equal
typedef _Hashtable::allocator_type | allocator_type
typedef allocator_type::pointer | pointer
typedef allocator_type::const_pointer | const_pointer
typedef allocator_type::reference | reference
typedef allocator_type::const_reference | const_reference
typedef _Hashtable::iterator | iterator
typedef _Hashtable::const_iterator | const_iterator
typedef _Hashtable::local_iterator | local_iterator
typedef _Hashtable::const_local_iterator | const_local_iterator
typedef _Hashtable::size_type | size_type
typedef _Hashtable::difference_type | difference_type

## Public Member Functions

| unordered_multiset (size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
template<typename _InputIterator >
| unordered_multiset (_InputIterator __f, _InputIterator __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
| unordered_multiset (const unordered_multiset &)=default
| unordered_multiset (unordered_multiset &&)=default
| unordered_multiset (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
size_type | bucket (const key_type &__key) const
size_type | bucket_count () const noexcept
size_type | bucket_size (size_type __n) const
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear () noexcept
size_type | count (const key_type &__x) const
template<typename... _Args>
iterator | emplace (_Args &&...__args)
template<typename... _Args>
iterator | emplace_hint (const_iterator __pos, _Args &&...__args)
bool | empty () const noexcept
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
allocator_type | get_allocator () const noexcept
hasher | hash_function () const
template<typename _InputIterator >
void | insert (_InputIterator __first, _InputIterator __last)
void | insert (initializer_list< value_type > __l)
key_equal | key_eq () const
float | load_factor () const noexcept
size_type | max_bucket_count () const noexcept
float | max_load_factor () const noexcept
void | max_load_factor (float __z)
size_type | max_size () const noexcept
unordered_multiset & | operator= (const unordered_multiset &)=default
unordered_multiset & | operator= (unordered_multiset &&__x)=default
unordered_multiset & | operator= (initializer_list< value_type > __l)
void | rehash (size_type __n)
void | reserve (size_type __n)
size_type | size () const noexcept
void | swap (unordered_multiset &__x)
iterator | begin () noexcept
const_iterator | begin () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
iterator | insert (const value_type &__x)
iterator | insert (value_type &&__x)
iterator | insert (const_iterator __hint, const value_type &__x)
iterator | insert (const_iterator __hint, value_type &&__x)
iterator | erase (const_iterator __position)
iterator | erase (iterator __it)
iterator | find (const key_type &__x)
const_iterator | find (const key_type &__x) const
std::pair< iterator, iterator > | equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
local_iterator | begin (size_type __n)
const_local_iterator | begin (size_type __n) const
const_local_iterator | cbegin (size_type __n) const
local_iterator | end (size_type __n)
const_local_iterator | end (size_type __n) const
const_local_iterator | cend (size_type __n) const

## Friends

template<typename _Value1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 >
bool | operator== (const unordered_multiset< _Value1, _Hash1, _Pred1, _Alloc1 > &, const unordered_multiset< _Value1, _Hash1, _Pred1, _Alloc1 > &)

## Detailed Description

### template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>
class std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >

A standard container composed of equivalent keys (possibly containing multiple of each key value) in which the elements' keys are the elements themselves.

Template Parameters

  _Value | Type of key objects.
  _Hash | Hashing function object type, defaults to hash<_Value>.
  _Pred | Predicate function object type, defaults to equal_to<_Value>.
  _Alloc | Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

Base is _Hashtable, dispatched at compile time via template alias __umset_hashtable.

Definition at line 698 of file unordered_set.h.

## Member Typedef Documentation

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::allocator_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 711 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 721 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 723 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef allocator_type::const_pointer std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 717 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef allocator_type::const_reference std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 719 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::difference_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 725 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::hasher std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 709 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 720 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::key_equal std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 710 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::key_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 707 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 722 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef allocator_type::pointer std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 716 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef allocator_type::reference std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 718 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 724 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

typedef _Hashtable::value_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 708 of file unordered_set.h.

## Constructor & Destructor Documentation

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | size_type | __n = `10`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline explicit

Default constructor creates no elements.

Parameters

  __n | Initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Definition at line 737 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>
template<typename _InputIterator >

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | _InputIterator | __f,
|  | _InputIterator | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_multiset from a range.

Parameters

  __first | An input iterator.
  __last | An input iterator.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multiset consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 758 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy constructor.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && |  | ) |

default

Move constructor.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::unordered_multiset | ( | initializer_list< value_type > | __l,
|  | size_type | __n = `0`,
|  | const hasher & | __hf = `hasher()`,
|  | const key_equal & | __eql = `key_equal()`,
|  | const allocator_type & | __a = `allocator_type()`
| ) |  |

inline

Builds an unordered_multiset from an initializer_list.

Parameters

  __l | An initializer_list.
  __n | Minimal initial number of buckets.
  __hf | A hash functor.
  __eql | A key equality functor.
  __a | An allocator object.

Create an unordered_multiset consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 783 of file unordered_set.h.

## Member Function Documentation

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) |

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 848 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 852 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) |

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1175 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::begin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1179 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::bucket_count | ( |  | ) | const

inline noexcept

Returns the number of buckets of the unordered_multiset.

Definition at line 1141 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cbegin | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points to the first element in the unordered_multiset.

Definition at line 875 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cbegin | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1183 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cend | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 883 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::cend | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1203 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::clear | ( |  | ) |

inline noexcept

Erases all elements in an unordered_multiset.

Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1059 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::count | ( | const key_type & | __x | ) | const

inline

Finds the number of elements.

Parameters

  __x | Element to located.

Returns
  Number of elements with specified key.

Definition at line 1118 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>
template<typename... _Args>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace | ( | _Args &&... | __args | ) |

inline

Builds and insert an element into the unordered_multiset.

Parameters

  __args | Arguments used to generate an element.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 897 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>
template<typename... _Args>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::emplace_hint | ( | const_iterator | __pos,
|  | _Args &&... | __args
| ) |  |

inline

Inserts an element into the unordered_multiset.

Parameters

  __pos | An iterator that serves as a hint as to where the element should be inserted.
  __args | Arguments used to generate the element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html

Insertion requires amortized constant time.

Definition at line 919 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

bool std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::empty | ( |  | ) | const

inline noexcept

Returns true if the unordered_multiset is empty.

Definition at line 827 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) |

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 862 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( |  | ) | const

inline noexcept

Returns a read-only (constant) iterator that points one past the last element in the unordered_multiset.

Definition at line 866 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) |

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1195 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_local_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::end | ( | size_type | __n | ) | const

inline

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters

  __n | The bucket index.

Returns
  A read-only local iterator.

Definition at line 1199 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::pair<iterator, iterator> std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) |

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1129 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

std::pair<const_iterator, const_iterator> std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::equal_range | ( | const key_type & | __x | ) | const

inline

Finds a subsequence matching given key.

Parameters

  __x | Key to be located.

Returns
  Pair of iterators that possibly points to the subsequence matching given key.

Definition at line 1133 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __position | ) |

inline

Erases an element from an unordered_multiset.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1005 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | iterator | __it | ) |

inline

Erases an element from an unordered_multiset.

Parameters

  __position | An iterator pointing to the element to be erased.

Returns
  An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1010 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const key_type & | __x | ) |

inline

Erases elements according to the provided key.

Parameters

  __x | Key of element to be erased.

Returns
  The number of elements erased.

This function erases all the elements located by the given key from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1028 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last
| ) |  |

inline

Erases a [__first,__last) range of elements from an unordered_multiset.

Parameters

  __first | Iterator pointing to the start of the range to be erased.
  __last | Iterator pointing to the end of the range to be erased.

Returns
  The iterator __last.

This function erases a sequence of elements from an unordered_multiset.

Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1048 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) |

inline

Tries to locate an element in an unordered_multiset.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1104 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

const_iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::find | ( | const key_type & | __x | ) | const

inline

Tries to locate an element in an unordered_multiset.

Parameters

  __x | Element to be located.

Returns
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 1108 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

allocator_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::get_allocator | ( |  | ) | const

inline noexcept

Returns the allocator object with which the unordered_multiset was constructed.

Definition at line 820 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

hasher std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::hash_function | ( |  | ) | const

inline

Returns the hash functor object with which the unordered_multiset was constructed.

Definition at line 1080 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const value_type & | __x | ) |

inline

Inserts an element into the unordered_multiset.

Parameters

  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 931 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | value_type && | __x | ) |

inline

Inserts an element into the unordered_multiset.

Parameters

  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Insertion requires amortized constant time.

Definition at line 935 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | const value_type & | __x
| ) |  |

inline

Inserts an element into the unordered_multiset.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html

Insertion requires amortized constant.

Definition at line 957 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

iterator std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | const_iterator | __hint,
|  | value_type && | __x
| ) |  |

inline

Inserts an element into the unordered_multiset.

Parameters

  __hint | An iterator that serves as a hint as to where the element should be inserted.
  __x | Element to be inserted.

Returns
  An iterator that points to the inserted element.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html

Insertion requires amortized constant.

Definition at line 961 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>
template<typename _InputIterator >

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) |  |

inline

A template function that inserts a range of elements.

Parameters

  __first | Iterator pointing to the start of the range to be inserted.
  __last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 975 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) |

inline

Inserts a list of elements into the unordered_multiset.

Parameters

  __l | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 986 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

key_equal std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::key_eq | ( |  | ) | const

inline

Returns the key comparison object with which the unordered_multiset was constructed.

Definition at line 1086 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

float std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::load_factor | ( |  | ) | const

inline noexcept

Returns the average number of elements per bucket.

Definition at line 1211 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_bucket_count | ( |  | ) | const

inline noexcept

Returns the maximum number of buckets of the unordered_multiset.

Definition at line 1146 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

float std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( |  | ) | const

inline noexcept

Returns a positive number that the unordered_multiset tries to keep the load factor less than or equal to.

Definition at line 1217 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_load_factor | ( | float | __z | ) |

inline

Change the unordered_multiset maximum load factor.

Parameters

  __z | The new maximum load factor.

Definition at line 1225 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::max_size | ( |  | ) | const

inline noexcept

Returns the maximum size of the unordered_multiset.

Definition at line 837 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

unordered_multiset& std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | const unordered_multiset< _Value, _Hash, _Pred, _Alloc > & |  | ) |

default

Copy assignment operator.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

unordered_multiset& std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > && | __x | ) |

default

Move assignment operator.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

unordered_multiset& std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) |

inline

Unordered_multiset list assignment operator.

Parameters

  __l | An initializer_list.

This function fills an unordered_multiset with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_multiset and that the resulting unordered_set's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 811 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::rehash | ( | size_type | __n | ) |

inline

May rehash the unordered_multiset.

Parameters

  __n | The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_multiset maximum load factor.

Definition at line 1236 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::reserve | ( | size_type | __n | ) |

inline

Prepare the unordered_multiset for a specified number of elements.

Parameters

  __n | Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 1247 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

size_type std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::size | ( |  | ) | const

inline noexcept

Returns the size of the unordered_multiset.

Definition at line 832 of file unordered_set.h.

template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>

void std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::swap | ( | unordered_multiset< _Value, _Hash, _Pred, _Alloc > & | __x | ) |

inline

Swaps data with another unordered_multiset.

Parameters

  __x | An unordered_multiset of the same element and allocator types.

This exchanges the elements between two sets in constant time. Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 1072 of file unordered_set.h.

The documentation for this class was generated from the following file:

- unordered_set.h